/*
 * Copyright (c) 2008, CIPmap-authors
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright notice,
 *       this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * The names of CIPmap's contributors may not be used to endorse or
 *       promote products derived from this software without specific prior
 *       written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>

#define CM_BUFFERSIZE 1024

typedef gchar *(*CmToStringFunc)(gpointer data);

void cm_list_print(GList *list, const gchar *title, CmToStringFunc to_string);
/*void cm_hash_table_print(GHashTable *table, const gchar *title,
    CmToStringFunc key_to_string, CmToStringFunc value_to_string);*/

gchar *cm_strreplace(const gchar *string, const gchar *victim, const gchar *replacement);

gchar *cm_strnext(gchar **string, gchar *delimiters);
gchar *cm_strnext_peek(gchar *string, gchar *delimiters);
gchar *cm_strnext_impl(gchar **string, gchar *delimiters, gboolean peek);
gboolean cm_char_in_set(gchar c, gchar *set);

gboolean cm_file_copy(const gchar *srcfile, const gchar *destfile,
                      GError **error);
gboolean cm_copy(const gchar *srcpath, const gchar *destpath,
                 gboolean recursive, GError **error);

GList *cm_dir_get_items(const gchar *path, GError **error);
void cm_dir_item_list_free(GList *dir_item_list);
